/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/

package lsagpi;

import java.awt.Image;
import java.awt.image.ImageObserver;
import java.util.Vector;

/**
 * Dibuja los bordes de los elementos de cuarto actual.
 * @author Miguel Angel Pescador Santirso
 */
public class DibujarCajas {

Vector<int[]> posiciones=new Vector<int[]>();
Vector<String> cadenas=new Vector<String>();
Vector<Elemento> elementos=new Vector<Elemento>();
/**
 * Constructor Dibujar Cajas.
 * @param elemens elementos del cuarto actual.
 * @param obs Observador.
 */
    public DibujarCajas(Vector elemens,ImageObserver obs){
        elementos=elemens;
        for(int i=0;i<elementos.size();i++){
            int[] pos=new int[4];
            Elemento elem=(Elemento)elementos.get(i);
            //System.out.println("Nombre elemento: "+elem.nombre);
            int[] poselem=elem.getPosicion();
            pos[0]=poselem[0];
            pos[1]=poselem[1];
            //System.out.println("Posicion elemento: "+pos[0]+":"+pos[1]);
            Image elementoImagen=elem.getImagen();
            if(poselem[2]!=0){
                double esc=((double)poselem[2])/100;
                pos[3] = (int)( esc*elem.getImagen().getWidth(null) );
                pos[2] = (int)( esc*elem.getImagen().getHeight(null) );
            }else{
            pos[2]=elementoImagen.getHeight(obs);
            pos[3]=elementoImagen.getWidth(obs);
            //System.out.println("AltoxAncho: "+pos[0]+":"+pos[1]);
            }
            //System.out.println(pos[0]+":"+pos[1]+":"+pos[2]+":"+pos[3]);
            posiciones.add(pos);
            cadenas.add(elem.nombre);
        }
    }
    /**
     * Evalua la posicion para determinar si hay algun elemento. En caso de que
     * no haya elementos devuelve "".
     * @param x posicion x.
     * @param y posicion y.
     * @return String Devuelve el nombre del elemento en esa posicion.
     */
    public String evaluarPosicion(int x, int y ){
        String mensaje=new String("");
        for(int i=0;i<cadenas.size();i++){
            int[] pos=posiciones.get(i);
            //System.out.println(pos[0]+":"+pos[1]+":"+(pos[1]+pos[2])+":"+(pos[0]+pos[3]));
            if(pos[0]<x && pos[1]>y && (pos[1]-pos[2])<y && (pos[3]+pos[0])>x)
                mensaje=cadenas.get(i);
        }
        return mensaje;
    }
    /**
     * Evalua la posicion para determinar si hay algun elemento. En caso de que no
     * haya elementos devuelve elemento vacio descripcion= "",nombre="vacio".
     * @param x posicion x.
     * @param y posicion y.
     * @return Elemento Devuelve el elemento en esa posicion.
     */
    public Elemento getElemento(int x,int y){

        Elemento ele=new Elemento("","vacio");
        for(int i=0;i<elementos.size();i++){
            int[] pos=posiciones.get(i);
            //System.out.println(pos[0]+":"+pos[1]+":"+(pos[1]+pos[2])+":"+(pos[0]+pos[3]));
            if(pos[0]<x && pos[1]>y && (pos[1]-pos[2])<y && (pos[3]+pos[0])>x){
                ele=elementos.get(i);
            }
        }
        return ele;
    }

}
