/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/


package lsagpi;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTree;
import javax.swing.JViewport;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLFrameHyperlinkEvent;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;

/**
 * Clase que gestiona el Indice de la Ayuda.
 * @author Miguel Angel Pescador Santirso
 */
class Indice extends JDialog {
		JPanel contenedor=new JPanel();
		JPanel tree=new JPanel();
		JPanel dibujo=new JPanel();
		JPanel botones=new JPanel();
		JEditorPane ep=new JEditorPane();
		JScrollPane sp=new JScrollPane(ep);
		JButton aceptar=new JButton("Aceptar");

        /**
         * Constructor del Indice de ayuda.
         * @param propietario Dialogo padre del Indice.
         */
		public Indice(final JFrame propietario){
			super(propietario,"Indice",true);

			DefaultMutableTreeNode top = new DefaultMutableTreeNode("Ayuda");
			ep.setEditable(false);
        		crearNodos(top);
			final JTree tree = new JTree(top);
        		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
			final JSplitPane split=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,tree,sp);
			split.setDividerLocation(100);
			tree.addTreeSelectionListener(new TreeSelectionListener() {
				public void valueChanged(TreeSelectionEvent e) {
					 DefaultMutableTreeNode node = (DefaultMutableTreeNode)	tree.getLastSelectedPathComponent();
					  if (node == null) return;
					  String nodeInfo = node.getUserObject().toString();
					  if (node.isLeaf()) {
					 	
					 	if (nodeInfo.equals("Acerca de LSAGPI")){
					 		seleccionarPagina("ayuda/Barra_de_Menus.html");
					 	}
					  	if (nodeInfo.equals("Requisitos mínimos")){
					 		seleccionarPagina("ayuda/Barra_de_Herramientas.html");
					 	}

					 	if (nodeInfo.equals("Instrucciones de Instalación")){
					 		seleccionarPagina("ayuda/Abrir.html");
					 	}
						if (nodeInfo.equals("Hola Mundo")){
					 		seleccionarPagina("ayuda/Comprimir.html");
					 	}
						if (nodeInfo.equals("Fondos y Animaciones")){
					 		seleccionarPagina("ayuda/Extraer.html");
					 	}
						if (nodeInfo.equals("Puertas")){
					 		seleccionarPagina("ayuda/Add.html");
					 	}
						if (nodeInfo.equals("Conversaciones Complejas")){
					 		seleccionarPagina("ayuda/ExtraerPocos.html");
					 	}
						if (nodeInfo.equals("Mejorando Animaciones")){
					 		seleccionarPagina("ayuda/Borrar.html");
					 	}
						if (nodeInfo.equals("Cabeceras de bloque")){
					 		seleccionarPagina("ayuda/NiveldeCompresion.html");
					 	}
						if (nodeInfo.equals("Variables de Sistema")){
					 		seleccionarPagina("ayuda/Temas.html");
					 	}

              				  }
              			}
              		 });

              		botones.setLayout(new GridLayout(1,4));
			botones.add(new JLabel(""));
			botones.add(new JLabel(""));
			botones.add(new JLabel(""));
			botones.add(aceptar);

			aceptar.addActionListener(new ActionListener(){public void actionPerformed(ActionEvent e){dispose();}});
			getContentPane().add(contenedor);
			contenedor.setLayout(new BorderLayout());
			contenedor.add("Center", split);
			contenedor.add("South",botones);
		}
            /**
             * Crea los nodos del arbol de contenidos.
             * @param top Modelo del nodo base.
             */
			public void crearNodos(DefaultMutableTreeNode top) {
        			DefaultMutableTreeNode category = null;
        			DefaultMutableTreeNode tipo = null;
				category = new DefaultMutableTreeNode("Manual de Usuario");
        		top.add(category);
        			tipo= new DefaultMutableTreeNode("Acerca de LSAGPI");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Requisitos mínimos");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Instrucciones de Instalación");
                    category.add(tipo);
				category = new DefaultMutableTreeNode("Tutoriales");
        		top.add(category);
                    tipo= new DefaultMutableTreeNode("Hola Mundo");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Fondos y Animaciones");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Puertas");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Conversaciones Simples");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Conversaciones Complejas");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Mejorando Animaciones");
                    category.add(tipo);
				category = new DefaultMutableTreeNode("Referencia rápida");
        		top.add(category);
        			tipo= new DefaultMutableTreeNode("Cabeceras de bloque");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Variables de Sistema");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Procedimientos");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Funciones");
                    category.add(tipo);
                    tipo= new DefaultMutableTreeNode("Operadores");
                    category.add(tipo);

			}
            /**
             * Selecciona la página por nombre de archivo.
             * @param pagina Nombre de archivo de la pagina.
             */
			public void seleccionarPagina(String pagina){
					try{
						File a=new File(pagina);
						URL url = new URL("file:///"+a.getAbsolutePath());
						if(url != null) {
    	          						ep.setPage(url);
       	    							ep.addHyperlinkListener(new Hyperactive());
								JViewport vp = sp.getViewport();
								vp.add(ep);
  		          				}
						}catch (MalformedURLException ex) {
   				        			String output="URL Incorrecta: "+ex;
	     							JOptionPane.showMessageDialog(null,output,"Error",JOptionPane.ERROR_MESSAGE);
		   				} catch (IOException ex) {
  								String output="Excepcion de E/S: "+ex;
    	  							JOptionPane.showMessageDialog(null,output,"Error",JOptionPane.ERROR_MESSAGE); }
			}
			class Hyperactive implements HyperlinkListener {
	         		public void hyperlinkUpdate(HyperlinkEvent e) {
 	          			if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
 		      				ep = (JEditorPane) e.getSource();
 		      				if (e instanceof HTMLFrameHyperlinkEvent) {
 		          				HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent)e;
 		          				HTMLDocument doc = (HTMLDocument)ep.getDocument();
 		          				doc.processHTMLFrameHyperlinkEvent(evt);
 		      				} else {
 		      		  	  		try {
 			      					ep.setPage(e.getURL());
 		         	 			} catch (Throwable t) {t.printStackTrace();}
 		      				}
 	          			}
 	      			}
     			}




	}
